WeekKeys.DB = {}
function WeekKeys.DB.RemoveReward()
    local player = UnitName("player")
    for _,v in pairs(WeekKeysDB.Characters) do
        if v.name == player then
            v.reward = nil
        end
    end
    
end
-- /dump WeekKeys.DB.OldGetAllByFaction(WeekKeysDB.Characters)
function WeekKeys.DB.OldGetAllByFaction(DB)
    local faction = UnitFactionGroup("player"):sub(1,1)
    local str = ""
    for _,playerdata in pairs(DB) do
        if playerdata.faction == faction then
            str = str .. "_" .. WeekKeys.Convert.OldTableToString(playerdata)
        end
    end
    return select(2,strsplit("_",str))
end

function WeekKeys.DB.GetAllByFaction(DB)
    local faction = UnitFactionGroup("player"):sub(1,1)
    local str = ""
    for _,playerdata in pairs(DB) do
        if playerdata.faction == faction then
            str = str .. "_" .. WeekKeys.Convert.TableToString(playerdata)
        end
    end
    return str
end

function WeekKeys.DB.GetAll(DB)
    if not DB then
        return
    end
    local str = ""
    for _,playerdata in pairs(DB) do
        str = str .. "_" .. WeekKeys.Convert.TableToString(playerdata)
    end
    return str
end

function WeekKeys.DB.SaveVars(DB, name, realm, classID, ilvl, record, keyid, keylevel, faction, sender)
    if name == "" or realm == "" or tonumber(classID) == nil  then
        return
    end
    for k,v in pairs(DB) do
        if v.name == name and v.realm == realm then
            if record then
                v.record = record
            end
            if ilvl then
                v.ilvl = tonumber(ilvl)
            end
            if classID then
                v.classID = tonumber(classID)
            end
            if keyid then
                v.keyID = tonumber(keyid)
            end
            if keylevel then
                v.keyLevel = tonumber(keylevel)
            end
            if faction then
                v.faction = faction
            end
            if sender then
                v.sender = sender
            end
            return
        end
    end
    tinsert(DB,{
        ["name"] = name,
        ["realm"] = realm,
        ["classID"] = tonumber(classID),
        ["record"] = tonumber(record),
        ["ilvl"] = tonumber(ilvl),
        ["keyLevel"] = tonumber(keylevel),
        ["keyID"] = tonumber(keyid),
        ["faction"] = faction,
        ["sender"] = sender,
    })
end
--GetFactionCovenant

function WeekKeys.DB.GetFactionCovenant(DB, tbl)
    if not DB then
        return
    end
    local realmname = string.lower(GetNormalizedRealmName())
    tbl = tbl or {}

    tbl[1] = wipe(tbl[1] or {})  -- фракция
    tbl[2] = wipe(tbl[2] or {})  -- ник, покрашеный
    tbl[3] = wipe(tbl[3] or {}) -- илвл
    tbl[4] = wipe(tbl[4] or {}) -- рекорд
    tbl[5] = wipe(tbl[5] or {}) -- ключ
    tbl[6] = wipe(tbl[6] or {}) -- недельный сундук
    tbl[7] = wipe(tbl[7] or {})

    for index,char in pairs(DB) do
        tbl[1][index] = char.faction
        local _, classFile, _ = GetClassInfo(char.classID)
        local _, _, _, argbHex = GetClassColor(classFile)
        tbl[2][index] = "|c"..argbHex..char.name.."|r"
        if string.lower(char.realm) ~= realmname then
            tbl[2][index] = tbl[2][index] .. " (*)"
        end
        tbl[3][index] = char.ilvl
        tbl[4][index] = char.record
        if char.keyID then
            tbl[5][index] = string.format("%s (%d)",C_ChallengeMode.GetMapUIInfo(char.keyID), char.keyLevel)
--[[
            if char.keyID == 375 or char.keyID == 377 then
                tbl[5][index] = "|Tinterface/icons/ui_sigil_nightfae.blp:20:20|t" .. tbl[5][index] 
            elseif char.keyID == 376 or char.keyID == 381 then
                tbl[5][index] = "|Tinterface/icons/ui_sigil_kyrian.blp:20:20|t" .. tbl[5][index]
            elseif char.keyID == 378 or char.keyID == 380 then
                tbl[5][index] =  "|Tinterface/icons/ui_sigil_venthyr.blp:20:20|t" .. tbl[5][index] 
            elseif char.keyID == 379 or char.keyID == 382 then
                tbl[5][index] =  "|Tinterface/icons/ui_sigil_necrolord.blp:20:20|t" .. tbl[5][index]
            end
        ]]
        else
            tbl[5][index] = ""
        end
        tbl[6][index] = char.reward
        tbl[7][index] = char.covenant
    end

    return tbl
end

function WeekKeys.DB.SaveVars2(DB, name, realm, classID, ilvl, record, keyid, keylevel, faction, covenant)
    if name == "" or realm == "" or tonumber(classID) == nil  then
        return
    end
    for k,v in pairs(DB) do
        if v.name == name and v.realm == realm then
            if record then
                v.record = record
            end
            if ilvl then
                v.ilvl = tonumber(ilvl)
            end
            if classID then
                v.classID = tonumber(classID)
            end
            if keyid then
                v.keyID = tonumber(keyid)
            end
            if keylevel then
                v.keyLevel = tonumber(keylevel)
            end
            if faction then
                v.faction = faction
            end
            if covenant then
                v.covenant = covenant
            end
            return
        end
    end
    tinsert(DB,{
        ["name"] = name,
        ["realm"] = realm,
        ["classID"] = tonumber(classID),
        ["record"] = tonumber(record),
        ["ilvl"] = tonumber(ilvl),
        ["keyLevel"] = tonumber(keylevel),
        ["keyID"] = tonumber(keyid),
        ["faction"] = faction,
        ["covenant"] = covenant
    })
end

function WeekKeys.DB.SaveTable(DB,tbl)
    for _,v in pairs(DB) do
        if v.name == tbl.name and v.realm == tbl.realm then
            for index,value in pairs(tbl) do
                v[index] = value
            end
            return
        end
    end
    if v.name and v.realm then
        tinsert(DB,tbl)
    end
end
function WeekKeys.DB.GetCharsByNameRealm(DB,name,realm,tbl)
    if not DB then
        return
    end
    tbl = tbl or {}

    tbl[1] = wipe(tbl[1] or {})  -- фракция
    tbl[2] = wipe(tbl[2] or {})  -- ник, покрашеный
    tbl[3] = wipe(tbl[3] or {}) -- илвл
    tbl[4] = wipe(tbl[4] or {}) -- рекорд
    tbl[5] = wipe(tbl[5] or {}) -- ключ
    tbl[6] = wipe(tbl[6] or {}) -- недельный сундук
    for index,char in pairs(DB) do

    end
    
end
-- /dump WeekKeys.DB.GetFormattedData(WeekKeysDB.Characters)
function WeekKeys.DB.GetFormattedData(DB, tbl)
    if not DB then
        return
    end
    local realmname = string.lower(GetNormalizedRealmName())
    tbl = tbl or {}

    tbl[1] = wipe(tbl[1] or {})  -- фракция
    tbl[2] = wipe(tbl[2] or {})  -- ник, покрашеный
    tbl[3] = wipe(tbl[3] or {}) -- илвл
    tbl[4] = wipe(tbl[4] or {}) -- рекорд
    tbl[5] = wipe(tbl[5] or {}) -- ключ
    tbl[6] = wipe(tbl[6] or {}) -- недельный сундук

    for index,char in pairs(DB) do
        tbl[1][index] = char.faction
        local _, classFile, _ = GetClassInfo(char.classID)
        local _, _, _, argbHex = GetClassColor(classFile)
        tbl[2][index] = "|c"..argbHex..char.name.."|r"
        if string.lower(char.realm) ~= realmname then
            tbl[2][index] = tbl[2][index] .. " (*)"
        end
        tbl[3][index] = char.ilvl
        tbl[4][index] = char.record
        if char.keyID then
            tbl[5][index] = string.format("%s (%d)",C_ChallengeMode.GetMapUIInfo(char.keyID), char.keyLevel)
            if char.keyID == 375 or char.keyID == 377 then
                tbl[5][index] = "|Tinterface/icons/ui_sigil_nightfae.blp:20:20|t" .. tbl[5][index] 
            elseif char.keyID == 376 or char.keyID == 381 then
                tbl[5][index] = "|Tinterface/icons/ui_sigil_kyrian.blp:20:20|t" .. tbl[5][index]
            elseif char.keyID == 378 or char.keyID == 380 then
                tbl[5][index] =  "|Tinterface/icons/ui_sigil_venthyr.blp:20:20|t" .. tbl[5][index] 
            elseif char.keyID == 379 or char.keyID == 382 then
                tbl[5][index] =  "|Tinterface/icons/ui_sigil_necrolord.blp:20:20|t" .. tbl[5][index]
            end
        else
            tbl[5][index] = ""
        end
        tbl[6][index] = char.reward
    end

    return tbl
end

function WeekKeys.DB.GetChar(DB, name, realm)
    if not DB then return end
    for _,char in pairs(DB) do
        if char.name == name and char.realm == realm then
            local _, classFile, _ = GetClassInfo(char.classID)
            local _, _, _, argbHex = GetClassColor(classFile)
            return  "|c"..argbHex..char.name.."|r", char.ilvl, char.record, string.format("%s (%d)",C_ChallengeMode.GetMapUIInfo(char.keyID), char.keyLevel)
        end
    end
    return
end
function WeekKeys.DB.Remove(args)
    -- to do
end
